Imports Microsoft.VisualBasic
Imports System
Imports System.Collections.Generic
Imports System.ComponentModel
Imports System.Data
Imports System.Drawing
Imports System.Linq
Imports System.Text
Imports System.Windows.Forms
Imports Telerik.WinControls.UI

Namespace _140349
	Public Partial Class Form1
		Inherits Form
		Public Sub New()
			InitializeComponent()
			radDateTimePicker1.Format = DateTimePickerFormat.Custom
			radDateTimePicker1.CustomFormat = "dd/MM/yyyy"

			Dim provider As MaskDateTimeProvider = (TryCast(Me.radDateTimePicker1.DateTimePickerElement.TextBoxElement.Provider, MaskDateTimeProvider))
			AddHandler provider.TextBoxItem.KeyDown, AddressOf TextBoxItem_KeyDown

		End Sub

		Private day As Integer = 0
		Private month As Integer = 0
		Private year As Integer = 0
		Private Sub TextBoxItem_KeyDown(ByVal sender As Object, ByVal e As KeyEventArgs)
			If e.KeyData = Keys.Decimal OrElse e.KeyData = Keys.Divide Then
				Dim item As Telerik.WinControls.UI.RadTextBoxItem = TryCast(sender, Telerik.WinControls.UI.RadTextBoxItem)
				Dim element As Telerik.WinControls.UI.RadMaskedEditBoxElement = TryCast(item.Parent, Telerik.WinControls.UI.RadMaskedEditBoxElement)
				Dim provider As Telerik.WinControls.UI.MaskDateTimeProvider = TryCast(element.Provider, Telerik.WinControls.UI.MaskDateTimeProvider)
				provider.SelectNextEditableItem()
				day = 0
				month = 0
				year = 0

			ElseIf (e.KeyCode >= Keys.D0 AndAlso e.KeyCode <= Keys.D9) OrElse (e.KeyCode >= Keys.NumPad0 AndAlso e.KeyCode <= Keys.NumPad9) OrElse e.KeyCode = Keys.Decimal Then


				Dim item As Telerik.WinControls.UI.RadTextBoxItem = TryCast(sender, Telerik.WinControls.UI.RadTextBoxItem)
				Dim element As Telerik.WinControls.UI.RadMaskedEditBoxElement = TryCast(item.Parent, Telerik.WinControls.UI.RadMaskedEditBoxElement)
				Dim provider As Telerik.WinControls.UI.MaskDateTimeProvider = TryCast(element.Provider, Telerik.WinControls.UI.MaskDateTimeProvider)



				Select Case provider.List(provider.SelectedItemIndex).type

					Case Telerik.WinControls.UI.PartTypes.Day
						If day = 0 Then
							provider.List(provider.SelectedItemIndex).value = 0
						End If
						day += 1
					Case Telerik.WinControls.UI.PartTypes.Month
						If month = 0 Then
							provider.List(provider.SelectedItemIndex).value = 12
						End If
						month += 1
					Case Telerik.WinControls.UI.PartTypes.Year
						If year = 4 Then
							year = 0
						End If
						If year = 0 Then
							provider.List(provider.SelectedItemIndex).value = 1900
						End If
						year += 1
				End Select

				If day = 3 Then
					provider.SelectNextEditableItem()
					provider.List(provider.SelectedItemIndex).value = 12
					day = 0
					month += 1
				End If
				If month = 3 Then
					provider.SelectNextEditableItem()
					provider.List(provider.SelectedItemIndex).value = 1900
					month = 0
					year += 1
				End If
			ElseIf e.KeyData = Keys.Left OrElse e.KeyData = Keys.Right OrElse e.KeyData = Keys.Divide Then
				day = 0
				month = 0
				year = 0
			End If
		End Sub
	End Class
End Namespace
